VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDirectDraw"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Sub InitDirectDraw()
    'Purpose: Initializng DirectDraw
    With GameOptions
        Set DD = DirectX.DirectDrawCreate(.DDGuid)
        DD.SetCooperativeLevel frmMain.hwnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWMODEX
        DD.SetDisplayMode .ResX, .ResY, .BPP, 0, DDSDM_DEFAULT 'Use the configured resolution


         With DDSDFront
            .lFlags = DDSD_CAPS
            .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_VIDEOMEMORY
         End With
         Set DDSFront = DD.CreateSurface(DDSDFront)
        
        
        With DDSDFront
            .lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT
            .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN Or DDSCAPS_3DDEVICE 'Act as a 3D device
            .lWidth = GameOptions.ResX 'Width of screen
            .lHeight = GameOptions.ResY 'Height of screen
        End With
        
        Set DDSBack = DD.CreateSurface(DDSDFront)
        Set Direct3D = DD.GetDirect3D
        If .blnUseHardware = True Then 'If hardware is enabled...
            Set Device = Direct3D.CreateDevice("IID_IDirect3DHALDevice", DDSBack)
        Else
            Set Device = Direct3D.CreateDevice("IID_IDirect3DRGBDevice", DDSBack)
        End If
        
        With DDSBack
         .GetSurfaceDesc RectCaps
         .SetForeColor vbGreen
         .SetFontTransparency True
        End With
        
        With DDFXBack
         .lFill = 0
        End With
    End With
End Sub

Public Function LoadSurfaces() As Boolean
 'Purpose: Loading all the neccassary durfaces
 On Error GoTo ErrOccured
 
 Dim AppDir As String
 Dim SurfaceDesc As DDSURFACEDESC2
 AppDir = Tools.AppDir

 With SurfaceDesc
  .lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
  .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
  .lHeight = 768
  .lWidth = 640
  End With
  Set ddsBackGround = DD.CreateSurfaceFromFile(AppDir + "\graphics\bground.bmp", SurfaceDesc)
  With BackGroundRect
   .Left = 0
   .Right = 640
   .Top = 0
   .Bottom = 768
  End With
 
 
 With SurfaceDesc
  .lHeight = 480
  .lWidth = 640
 End With
 Set ddsSplashScreen = DD.CreateSurfaceFromFile(AppDir + "\graphics\splash.bmp", SurfaceDesc)
 
 With SurfaceDesc
  .lHeight = 481
  .lWidth = 530
 End With
 Set ddsSprites = DD.CreateSurfaceFromFile(AppDir + "\graphics\sprites.bmp", SurfaceDesc)
 Dim EmptyRect As RECT, tmpcolor As Long, TmpSurfacedesc As DDSURFACEDESC2
 Dim I As Integer, J As Integer, MaskColor As Long
   ddsSprites.Lock EmptyRect, TmpSurfacedesc, DDLOCK_WAIT, 0
   tmpcolor = ddsSprites.GetLockedPixel(1, 1)
   
   ReDim blnSpritesMask(SurfaceDesc.lWidth, SurfaceDesc.lHeight)
   For I = 0 To SurfaceDesc.lHeight - 1
    
    For J = 0 To SurfaceDesc.lWidth - 1
     MaskColor = ddsSprites.GetLockedPixel(J, I)
     If MaskColor <> tmpcolor Then
      blnSpritesMask(J, I) = False
     Else
      blnSpritesMask(J, I) = True
     End If
    Next J
   Next I
     
   
   ddsSprites.Unlock EmptyRect
   With ColorKey
   .low = tmpcolor
   .high = .low
   End With
   ddsSprites.SetColorKey DDCKEY_SRCBLT, ColorKey
 
    With SurfaceDesc
     .lHeight = 10
     .lWidth = 4
    End With
    Set ddsWeapon = DD.CreateSurfaceFromFile(AppDir + "\graphics\laser.bmp", SurfaceDesc)
    ddsWeapon.Lock EmptyRect, TmpSurfacedesc, DDLOCK_WAIT, 0
    tmpcolor = ddsWeapon.GetLockedPixel(0, 0)
  
   ReDim WeaponMask(SurfaceDesc.lWidth, SurfaceDesc.lHeight)
   For I = 0 To SurfaceDesc.lHeight - 1
    For J = 0 To SurfaceDesc.lWidth - 1
     MaskColor = ddsWeapon.GetLockedPixel(I, J)
     If MaskColor <> tmpcolor Then
      WeaponMask(J, I) = False
     Else
      WeaponMask(J, I) = True
     End If
    Next J
   Next I

    
    ddsWeapon.Unlock EmptyRect
     
     With ColorKey
     .low = tmpcolor
     .high = .low
     End With
    ddsWeapon.SetColorKey DDCKEY_SRCBLT, ColorKey 'Same key
 
 LoadSurfaces = True
 Exit Function

ErrOccured:
 LoadSurfaces = False
 MsgBox "(LoadSurfaces) Error: " & Err.Description
 UnloadAll
 End
End Function

