VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDirectSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Sub InitDirectSound()
    'Purpose: Initializing DirectSound
    On Local Error GoTo ErrorHandler
    Dim dsBDesc As DSBUFFERDESC, bdesc As DSBUFFERDESC
    Dim intCount As Integer
    Dim PrimDesc As DSBUFFERDESC, Format As WAVEFORMATEX
    
    Set DS = DirectX.DirectSoundCreate("")
    DS.SetCooperativeLevel frmMain.hwnd, DSSCL_PRIORITY
    
    PrimDesc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER
    Set DSPrimaryBuffer = DS.CreateSoundBuffer(PrimDesc, Format) 'Create pimary buffer
    Set DS3DListener = DSPrimaryBuffer.GetDirectSound3DListener() 'Create a 3D listener
Exit Sub

ErrorHandler:
    MsgBox "Unable to create Direct Sound object." & vbCrLf & "Check to ensure that a sound card is installed and working properly, and currently not in use by other programs."
    UnloadAll
    End
End Sub

Public Sub LoadWaveFile(DSBuffer As DirectSoundBuffer, DS3DBuffer As DirectSound3DBuffer, FileName As String)
    'Purpose: Loading a wavefile, containing a 3D buffer
    Dim BufferDesc1 As DSBUFFERDESC
    Dim WaveFormat1 As WAVEFORMATEX
 
    BufferDesc1.lFlags = (DSBCAPS_CTRL3D Or DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
    Set DSBuffer = DS.CreateSoundBufferFromFile(FileName, BufferDesc1, WaveFormat1)
    DSBuffer.SetVolume 0
 
    Set DS3DBuffer = DSBuffer.GetDirectSound3DBuffer
    DS3DBuffer.SetConeAngles DS3D_MINCONEANGLE, 100, DS3D_IMMEDIATE
    DS3DBuffer.SetConeOutsideVolume -400, DS3D_IMMEDIATE
End Sub

Public Sub LoadNormalWaveFile(DSBuffer As DirectSoundBuffer, FileName As String)
    'Purpose: Loading a wavefile, without a 3D buffer
    Dim BufferDesc1 As DSBUFFERDESC
    Dim WaveFormat1 As WAVEFORMATEX
 
    BufferDesc1.lFlags = (DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME) Or DSBCAPS_STATIC
    Set DSBuffer = DS.CreateSoundBufferFromFile(FileName, BufferDesc1, WaveFormat1)
    DSBuffer.SetVolume 0
End Sub

Public Sub PlaySound(DSBuffer As DirectSoundBuffer)
 'Purpose: Playing a sound (non looping)
 If GameOptions.Sounds = True Then
  DSBuffer.Play DSBPLAY_DEFAULT
 End If
End Sub

Public Sub PlayMusic(DSBuffer As DirectSoundBuffer, OnOff As Boolean)
 'Purpose: Playing/stopping music (looping)
 If GameOptions.Music = True Then
  If OnOff = True Then
   DSBuffer.Play DSBPLAY_LOOPING
  Else
   DSBuffer.Stop
  End If
 End If
End Sub

Public Sub LoadSoundFiles()
 'Purpose: Loading all the wavefiles in "DirectSound (3D)Buffers"
 'Checks first if file exists
    
    If Tools.FileAvailable(Tools.AppDir & "\sound\zap.wav") = True Then DSound.LoadWaveFile dsZap, dsZap3D, App.Path + "\sound\zap.wav"
    If Tools.FileAvailable(Tools.AppDir & "\sound\music.wav") = True Then DSound.LoadNormalWaveFile dsMusic, App.Path + "\sound\music.wav"
    If Tools.FileAvailable(Tools.AppDir & "\sound\shoot.wav") = True Then DSound.LoadWaveFile dsShoot, dsShoot3D, App.Path + "\sound\shoot.wav"
    If Tools.FileAvailable(Tools.AppDir & "\sound\transform.wav") = True Then DSound.LoadNormalWaveFile dsTransForm, App.Path + "\sound\transform.wav"
    If Tools.FileAvailable(Tools.AppDir & "\sound\enemy.wav") = True Then DSound.LoadNormalWaveFile dsEnemyHit, App.Path + "\sound\enemy.wav"
End Sub
