Attribute VB_Name = "mdlGame"
Option Explicit
'Name: Pinguin
'Created by Almar Joling
'E-Mail: ajoling@theheadoffice.com
'Website: http://www3.ewebcity.com/stqw
'Completed on 29/08/2000

Public Sub Main()
 On Error GoTo Errhandler
  'Purpose: Loading all neccassary data
    
    Set DirectX = New DirectX7          'This is faster than using the 'New' word directly.
    Set DDraw = New clsDirectDraw    'idem
    Set Tools = New clsTools             'idem
    Set DInput = New clsDirectInput   'idem
    Set DSound = New clsDirectSound 'idem
    
    frmDriverSelect.Show vbModal     'Show driver dialog

    If blnProceed = False Then          'if user pressed cancel, or did not complete setup, exit
     UnloadAll                                 'Unload everything
     End                                        'End
    End If
    
                                                  'If user pressed ok... run the game
    DDraw.InitDirectDraw                  'Initialise DirectDraw
    DInput.InitDInput                       'Initialise DirectInput
    DSound.InitDirectSound               'Initialise DirectSound
    
    DSound.LoadSoundFiles               'Load sound files
    DDraw.LoadSurfaces                   'Load surfaces
    ShowCursor 0
    ShowMenu                                'Show the "Press F1 dialog"
    InitLevel                                   'F1 was pressed, initialise level...
    lngStartTime = Minute(Now)                        'Set starttime to now
    dsMusic.SetCurrentPosition 0        'Set  music position to 0, should be 0 here... Just to be sure
    DSound.PlayMusic dsMusic, True   'Start music (The sub checks if music is enabled)
    
    GameLoop                                 'Enter the game loop
Exit Sub

Errhandler:
    MsgBox "(Main) Error: " & Err.Description, vbCritical + vbOKOnly, "Pinguin " & Tools.AppVersion
    UnloadAll
    End
End Sub

Public Sub UnloadAll()
 On Error GoTo Errhandler
  'Purpose: Unloading everything that this game has used.
    ShowCursor 1
    DIKeyBoard.Unacquire                    'Return keyboard to windows
    Set DI = Nothing
    
    Set ddsSplashScreen = Nothing       'Unload all surfaces
    Set ddsBackGround = Nothing
    Set ddsSprites = Nothing
    Set ddsWeapon = Nothing
    Set ddsScreenCopy = Nothing

    Set DSPrimaryBuffer = Nothing       'Unload all soundbuffers
    Set DS3DListener = Nothing
    Set dsZap = Nothing
    Set dsZap3D = Nothing
    Set dsMusic = Nothing
    Set dsShoot = Nothing
    Set dsShoot3D = Nothing
    Set dsTransForm = Nothing

    Set Device = Nothing                    'Unload 3D Devices...
    Set Direct3D = Nothing
    Set DDSBack = Nothing
    Set DDSFront = Nothing
    
    DD.RestoreDisplayMode                 'Restore display
    DD.SetCooperativeLevel frmMain.hwnd, DDSCL_NORMAL
    
    Set DD = Nothing                        'Unload the rest
    Set DirectX = Nothing
    Set DDraw = Nothing
    Set Tools = Nothing
    Set DInput = Nothing
    Set DSound = Nothing

Exit Sub
Errhandler:
Resume Next 'Doesn't matter what happens. Continue without notice
End Sub



Public Sub GameLoop()
 'Purpose: Animating the entire game.
 Dim EmptyRect As RECT
 Dim TempOld As Long
 Dim PauzeString As String
 'Static LastTick As Long
    NewAIGuy 'Immediatly show an enemy

    Do
    
        
            If (DirectX.TickCount - LastTick) > 20 Then '(1000/20) = 40-50fps
            DoEvents
            If blnPauzeGame = True Then        'When the game is pauzed...
                Do                                    'Do nothing. Only show the game pauzed message...
                    DInput.GetInput              'Wait for [P] to continue...
                    If blnPauzeGame = False Then Exit Do 'Exit if [P] was pressed
                    PauzeString = "Pauzed. Press [P] to continue"
                    DDSBack.DrawText GameOptions.ResX / 2 - 100 / 2, GameOptions.ResY, PauzeString, False
                    BlitToFront                     'Blit Text
                    DoEvents
                Loop
            End If
        
        DInput.GetInput                          'Get keyboard input
        DDSBack.BltColorFill EmptyRect, vbBlack     'Clear backbuffer
        DoEvents
        UpdateBackGround                       'Update scrolling background
        ShowEnemies                              'Update and draw enemies
        ShowWeapons                             'Update and draw weapons
        ShowStars                                  'Update and draw stars
        ShowBurgers                               'Update and draw burgers
        ShowPlayer                                 'Update and draw player ("Pinguin")
        AddRandomClouds                         'Add random clouds to the game
        AddRandomEnemies                       'Add random enemies to the game
        ShowClouds                                 'Update and draw clouds
        ShowInterFace                             'Show interface
        If GameOptions.FrameRate = True Then Tools.ShowFrameRate ' If framerate counter is visible, draw it.
        
        BlitToFront                                  'Blit to display.
        DoEvents                                   'Remove following line for extra speed!!
        LastTick = DirectX.TickCount         'Set lasttick to currenttick (for framerate limit)
        
        If Player.Lives < 0 Then Exit Do      'If player has no lives... Exit gameloop
        
        End If
    Loop

    DSound.PlayMusic dsMusic, False            'End music
                                                            'Player is dead (game over)
    LoadHighScores                                   'Load the highscores
    ShowEndMenu                                     'Show the "gameover" menu
    
    ShowMenu                                          'User choose "continue" in the gameover menu, show "Press F1" menu
    InitLevel                                             'Re-init level, set player properties correctly
    lngStartTime = Minute(Now)                   'Reset starttime to now
    dsMusic.SetCurrentPosition 0                  'Set music position to 0, or the music would just continue from where it left!
    DSound.PlayMusic dsMusic, True             'Play music
    GameLoop                                           'Call this sub again to enter the gameloop (again)
End Sub

Public Sub BlitToFront()
 'Purpose: Blitting the backbuffer to the front
 Dim ClientRect As RECT, EmptyRect As RECT
 With EmptyRect
  .Left = 0
  .Right = GameOptions.ResX
  .Top = 0
  .Bottom = GameOptions.ResY
 End With
    GetClientRect frmMain.hwnd, ClientRect          'Get RECT of this window
    ClientToScreen frmMain.hwnd, ClientRect.Left    'Convert it to screen coordinates
    ClientToScreen frmMain.hwnd, ClientRect.Right   'idem
    DDSFront.Blt ClientRect, DDSBack, EmptyRect, DDBLT_WAIT 'Blit back to front
End Sub

Public Sub InitLevel()
 'Purpose: reset/setup level data
    BackGroundX = (GameOptions.ResX / 2) - (BackGroundRect.Right / 2)  'Set the most left part of the background
    BackGroundY = 0        'Background starts at 0
    ReDim Enemies(0)       'Reset enemies (no preserve)
    ReDim Clouds(0)         'Reset clouds (no preserve)
    ReDim Burgers(0)        'Reset burgers (no preserve)
    ReDim Stars(0)           'Reset stars (no preserve)
    ReDim Weapons(0)
    TotalEnemies = 0        'Currently no enemies
    TotalClouds = 0          'Currently no clouds
    TotalBurgers = 0         'Currently no burgers
    TotalStars = 0            'Currently no stars
    TotalWeapons = 0
    lngEnemyHits = 1        'Enemy dies after one hit at the start
    With Player
        .X = GameOptions.ResX / 2 - 53       'Center Player X
        .Y = GameOptions.ResY - 120          'Set player to bottom of screen
        .Score = 0                                    'Reset score to 0
        .Lives = 2                                     'Reset Lives to 2
        .Shocks = -1                                 'Not shocked at the moment
        .NextLifeScore = 2000                     'Next player live at 2000
    End With
End Sub

Public Sub UpdateBackGround()
 'Purpose: Scrolling the background of this game
 
 Static lngNewY As Long
 Static lngTempVal As Long
 Dim lngNewVal As Long

    With BackGroundRect
        .Top = 168 + BackGroundY
        .Bottom = 768 + BackGroundY

        If lngNewY <> 0 Then
         lngNewY = lngNewY - 2
         lngTempVal = GameOptions.ResY - (768 - BackGroundY)
         SecRect.Bottom = 768
         SecRect.Top = 768 - lngTempVal
         DDSBack.BltFast BackGroundX, 0, ddsBackGround, SecRect, DDBLTFAST_NOCOLORKEY Or DDBLTFAST_WAIT
        End If
         
        If BackGroundY >= 768 Then
         BackGroundY = 0
         lngNewY = 0
        End If
        
        If .Bottom >= 768 Then
        .Bottom = 768 - BackGroundY
        .Top = .Bottom - GameOptions.ResY
        
        If .Top < 1 Then
         With SecRect
          .Left = BackGroundRect.Left
          .Right = BackGroundRect.Right
          .Top = BackGroundRect.Top
          .Bottom = BackGroundRect.Bottom
         End With
         lngNewY = BackGroundY
         .Top = 0
         End If
        End If
        
        If .Top = 0 Then
         lngTempVal = GameOptions.ResY - .Bottom
         DDSBack.BltFast BackGroundX, lngTempVal, ddsBackGround, BackGroundRect, DDBLTFAST_NOCOLORKEY Or DDBLTFAST_WAIT
        Else
         DDSBack.BltFast BackGroundX, 0, ddsBackGround, BackGroundRect, DDBLTFAST_NOCOLORKEY Or DDBLTFAST_WAIT
        End If
    End With
    
    BackGroundY = BackGroundY + 2
End Sub

Public Sub ShowMenu()
 'Purpose: Show the by Phantom supplied "Pinguin, press F1" screen
 Dim EmptyRect As RECT, SplashRect As RECT
 'Dim lngLastTick As Long
 
    DDSBack.BltColorFill EmptyRect, vbBlack            'Clear background
    With SplashRect
     .Top = 0
     .Left = 0
     .Right = 640      'Image Width
     .Bottom = 480   'Image Height
    End With
    
    blnWaitForF1 = True   'Wait till F1 is pressed
    
    Do
        If (DirectX.TickCount - LastTick) > 20 Then 'DirectInput won't work with a too high frame rate
            If blnWaitForF1 = False Then Exit Do   'Exit when F1 is pressed...
            DDSBack.BltFast (GameOptions.ResX / 2) - 320, (GameOptions.ResY / 2) - 240, ddsSplashScreen, SplashRect, DDBLTFAST_NOCOLORKEY Or DDBLTFAST_WAIT              'Blit splash on screen, in the center
            BlitToFront                                 'Blit it to the front
            DoEvents
            DInput.GetInput                          'Get input...
            DoEvents                                   'Allow some processor load to other programs...
            LastTick = DirectX.TickCount     'Set lasttick to the currenttick
        End If
    Loop
End Sub


Public Sub ShowPlayer()
 'Purpose: Animating the player, and also do some collision detection related to the player
 Dim PlayerRect As RECT, BurgerRect As RECT
 Dim I As Integer
 
    With PlayerRect
        .Left = 106 * Player.Frame
        .Right = .Left + 106
        .Top = 0
        .Bottom = 120
    End With
    'Create the 'rotor' animation
    Player.Frame = Player.Frame + 1
    If Player.Frame = 3 Then Player.Frame = 0
    
    'If player is not dead (yet)
    If Player.Lives <> -1 Then
        If Player.Shocks = 1 Then 'One mistake and lose a live...
            With PlayerRect 'Show ghost pinguin
                .Top = 186
                .Left = 400
                .Bottom = .Top + 120
                .Right = .Left + 106
            End With
            DDSBack.BltFast Player.X, Player.Y, ddsSprites, PlayerRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        Else                    'Blit normal pinguin
            DDSBack.BltFast Player.X, Player.Y, ddsSprites, PlayerRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
        End If
    End If
    
    For I = 1 To TotalBurgers 'Loop through all burgers
        If Burgers(I).Enabled = True Then 'Is burger enabled?
        'Current burger position...
        With BurgerRect
            .Top = Burgers(I).Y
            .Left = Burgers(I).X
            .Right = .Left + 60
            .Bottom = .Top + 43
        End With
        'Current player position...
        With PlayerRect
            .Top = Player.Y
            .Bottom = .Top + 120
            .Left = Player.X
            .Right = .Left + 106
        End With
    
        If Tools.DetectCollision(BurgerRect, PlayerRect) = True Then 'If a collision was found
            Burgers(I).Enabled = False
                If GameOptions.AlphaBurgers = True Then Burgers(I).Alpha = Burgers(I).Alpha - 0.02    'Fade out, if enabled at start
                    Player.Score = Player.Score + 50 '50 points for every burger! You won't get that at McDonald's!
                    
                    If Player.Score >= Player.NextLifeScore Then 'Player reached next life score
                        Player.Lives = Player.Lives + 1 'Add a live
                        Player.NextLifeScore = Player.NextLifeScore + 2000 'Next live at current score + 2000
                    End If
                End If
        End If
    Next I 'Check next burger


End Sub

Public Sub CollisionDetect(EnemyID As Integer)
 'Purpose: Collision detect player with enemies
 Dim TempRect As RECT, Temprect2 As RECT
 Dim Rect1 As RECT, Rect2 As RECT
 Dim I As Integer
 
    With Enemies(EnemyID)
        With Rect1 'Rect1 = Enemy!
            .Left = Enemies(EnemyID).X
            .Top = Enemies(EnemyID).Y
            .Right = .Left + 72
            .Bottom = .Top + 60
        End With
    '
        With Rect2 'Rect2 = Player!
            .Left = Player.X '+ 26.5 '106/4 = 26.5, a quarter of the pinguin size
            .Top = Player.Y
            .Bottom = .Top + 120
            .Right = .Left + 106
        End With
    
        If Tools.DetectCollision(Rect1, Rect2) = True Then 'Collision detected...
            DSound.PlaySound dsEnemyHit
            AddHit   'Add a 'hit' to the player
        End If
    
    For I = 1 To TotalWeapons   'Now do enemy-player weapon collision
        If Weapons(I).Enabled = True Then
            With Rect2 'Rect2 = Weapon!
            .Top = Weapons(I).Y
            .Left = Weapons(I).X
            .Right = .Left + 4
            .Bottom = .Top + 10
            End With
        
            If Tools.DetectCollision(Rect1, Rect2, 1) Then 'Intersect is good enough...that's the '1'
                Weapons(I).Enabled = False                         'Disable the weapon
                UpdateEnemyStatus EnemyID, I                    'Update the status of the enemy (add a hit)
            End If
        End If
    Next I
    End With
End Sub

Public Sub ShowInterFace()
 'Purpose: Showing the interface, eg: lives, score
 Dim TempRect As RECT, DestRect As RECT, ZoomRate As Single
 Dim lngCalculation As Long, I As Integer
    ZoomRate = 0.5
    Tools.ShowNumbers BackGroundX, 0, CStr(Player.Score)
    
    With TempRect 'The rect contains a pinguin...
        .Left = 106
        .Right = .Left + 106
        .Top = 0
        .Bottom = 120
    End With
    
    lngCalculation = (106 * ZoomRate) * (Player.Lives + 1) 'Calculate width of player images
    lngCalculation = (BackGroundX + 640) - lngCalculation   'Subtract that from the right part of the background (upper right)
    
    If Player.Lives <= 5 Then 'If the player has less or equal to 9 lives, show all else...
        For I = 0 To Player.Lives
            With DestRect
                .Left = lngCalculation + ((106 * ZoomRate) * I) 'Resize pinguin
                .Right = .Left + (106 * ZoomRate) '53  '53, because 106 /2 = 53
                .Top = 0
                .Bottom = (120 * ZoomRate) '60, because 120 /2 = 60
            End With
            DDSBack.Blt DestRect, ddsSprites, TempRect, DDBLT_KEYSRC Or DDBLT_WAIT 'Blit shrinked pinguin...
        Next I
    
    Else '...Show one pinguin with the live count right from it
        lngCalculation = (106 * ZoomRate) * 2.5 'Do not use Player.Lives
        lngCalculation = (BackGroundX + 640) - lngCalculation
        With DestRect
            .Left = lngCalculation '+ ((106 * ZoomRate) * 3)  'Extra to the left,create space for numbers
            .Right = .Left + (106 * ZoomRate) '53  '53, because 106 /2 = 53
            .Top = 0
            .Bottom = (120 * ZoomRate) '60, because 120 /2 = 60
        End With
        DDSBack.Blt DestRect, ddsSprites, TempRect, DDBLT_KEYSRC Or DDBLT_WAIT
        Tools.ShowNumbers DestRect.Right + 5, 0, CStr(Player.Lives) 'Show the number of lives
    End If

End Sub

Public Sub PlayerDies()
 'Purpose: Player dies...
Dim TempRect As RECT

    Player.Lives = -1 'To be sure...Set lives to -1 (death)
    If (DirectX.TickCount - Player.LastShock) > 1500 Then Player.Frame = 1 'if the last hit was 1.5secs ago...
    
    With TempRect 'Containing ghost image of the pinguin...
        .Top = 186
        .Left = 400
        .Bottom = .Top + 120
        .Right = .Left + 106
    End With
    DDSBack.BltFast Player.X - 63, Player.Y, ddsSprites, TempRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
    'EndScreen       'Show end screen
    
 
End Sub


Public Sub TransparantBlit(X As Long, Y As Long, BlitRect As RECT, Surface As DirectDrawSurface7, AlphaVal As Single, TransparantColor As Long)
 'Purpose: Creating a transparantblit without Direct3D (alpha blending)
 'Can be very slow. Turn off when necassary
 Dim SurfaceDesc As DDSURFACEDESC2, rEmpty As RECT, rEmpty2 As RECT
 Dim lColorV As Long, lColorB As Long, lNewColor As Long
 Dim iX As Long, iY As Long
 Dim SurfaceDesc2 As DDSURFACEDESC2

    Surface.GetSurfaceDesc SurfaceDesc
    Surface.Lock rEmpty, SurfaceDesc, DDLOCK_WAIT, 0
    DDSBack.GetSurfaceDesc SurfaceDesc2
    DDSBack.Lock rEmpty2, SurfaceDesc2, DDLOCK_WAIT, 0
    
    For iY = BlitRect.Top To BlitRect.Bottom
        For iX = BlitRect.Left To BlitRect.Right
            lColorV = Surface.GetLockedPixel(iX, iY)
            If lColorV <> TransparantColor Then 'If this pixel is the transparant one... do not show
                lColorB = DDSBack.GetLockedPixel(X + (iX - BlitRect.Left), Y + (iY - BlitRect.Top))
                lNewColor = SurfaceDesc2.ddpfPixelFormat.lRBitMask And (lColorV And SurfaceDesc.ddpfPixelFormat.lRBitMask) * AlphaVal + (lColorB And SurfaceDesc2.ddpfPixelFormat.lRBitMask) * (1 - AlphaVal)
                lNewColor = lNewColor Or (SurfaceDesc2.ddpfPixelFormat.lGBitMask And (lColorV And SurfaceDesc.ddpfPixelFormat.lGBitMask) * AlphaVal + (lColorB And SurfaceDesc2.ddpfPixelFormat.lGBitMask) * (1 - AlphaVal))
                lNewColor = lNewColor Or (SurfaceDesc2.ddpfPixelFormat.lBBitMask And (lColorV And SurfaceDesc.ddpfPixelFormat.lBBitMask) * AlphaVal + (lColorB And SurfaceDesc2.ddpfPixelFormat.lBBitMask) * (1 - AlphaVal))
                DDSBack.SetLockedPixel X + (iX - BlitRect.Left), Y + (iY - BlitRect.Top), lNewColor
            End If
        Next iX
    Next iY
    Surface.Unlock rEmpty ' Unlock
    DDSBack.Unlock rEmpty2 ' Unlock
End Sub

'Public Sub EndScreen()
 '
 'LoadHighScores
'End Sub

Public Sub LoadHighScores()
 'Purpose: Load the highscore from file
 Dim lngFreeFile As Integer
 Dim tempHighScore As Long
 Dim tempHighScoreName As String * 15
 Dim I As Integer
 
    lngFreeFile = FreeFile
    Open Tools.AppDir & "Scores.dat" For Binary Access Read As #lngFreeFile
        If EOF(lngFreeFile) = False Then
            Get #lngFreeFile, , lngHighScore 'If data found, load it
        Else
            tempHighScore = -1 'No data present? set to -1, player scores always higher than this one.
        End If
    Close #lngFreeFile
End Sub

'Public Function FindStringCenter(strInput As String) As Long
'
'    'This sub finds the approximate center of a string
'
'    Dim hdc As Long                             'Variable to store the device context handle
'    Dim ReturnResults As TEXTMETRIC             'textmetric type to hold the info we collect
'
'    hdc = DDSBack.GetDC                         'get the device context for the back buffer
'    GetTextMetrics hdc, ReturnResults           'call the GetTextMetrics api to gain information about the currently selected font
'    DDSBack.ReleaseDC hdc                       'release the handle
'
'    FindStringCenter = (GameOptions.ResX \ 2) - ((ReturnResults.tmAveCharWidth * Len(strInput)) \ 2)
'                                                'assign the new X position of the string to the function after we find the center of the string
'                                                'in relationship to the screen width and the average width of all characters in the font, and
'                                                'add the offset of the length of the string
'End Function

Public Sub AddHit()
 'Purpose: Add a 'shock' to the player
    With Player
        If (DirectX.TickCount - Player.LastShock) > 1500 Then
            .Shocks = .Shocks + 1
            If .Shocks >= 1 Then 'If one shock or more... remove a live
                .Lives = .Lives - 1
                .Shocks = 0
                .X = GameOptions.ResX / 2 'Center player X
                .Y = GameOptions.ResY - 120 'Put player on bottom of screen
            End If
        
            If .Lives < 0 Then PlayerDies 'No lives? Player dies...
           .LastShock = DirectX.TickCount 'Set Player lastshock to currenttick
        End If
    End With
End Sub

Public Sub ShowEndMenu()
 'Purpose: Showing the 'game over' menu
 Dim EmptyRect As RECT
 Dim NewFont As New StdFont, I As Long
 Dim lngFreeFile As Long
    Set ddsScreenCopy = DDSFront 'Copy current front, for background use
    blnWaitForSpace = True 'Wait till user pressed [Space]
    
    With NewFont 'Create a new font
        .Name = "Arial"
        .Size = 36
    End With
    DDSBack.SetFont NewFont 'Set new font active
    
    Do
        If (DirectX.TickCount - LastTick) > 20 Then 'Framerate limiter...
            DInput.GetInput
            With DDSBack
                .BltFast 0, 0, ddsScreenCopy, EmptyRect, DDBLTFAST_NOCOLORKEY 'Put Front as background (don't need to clear backbuffer)
                NewFont.Size = 36               'Set font size to 36...This is a loop, so this must be put in here
                .SetFont NewFont                'Enable font...
                .DrawText GameOptions.ResX / 2 - 120, 30, "Game over", False 'Draw "Game over"
                .DrawLine BackGroundX, 80, (BackGroundX + 640), 80              'Show line...
                NewFont.Size = 24               'Set font to 24
                .SetFont NewFont    'Enable font
                .DrawText GameOptions.ResX / 2 - 180, GameOptions.ResY - 40, "Press [Space] to continue", False 'draw text...
                
                If Player.Score > lngHighScore Then
                    'It's a new highscore!
                    DDSBack.DrawText GameOptions.ResX / 2 - 110, GameOptions.ResY / 2 - 100, "New highscore!", False 'Show it
                    DDSBack.DrawText GameOptions.ResX / 2 - 30, GameOptions.ResY / 2 - 50, Player.Score, False 'Show score
                    lngFreeFile = FreeFile               'Get a free filenumber
                    Open App.Path + "\scores.dat" For Binary As #lngFreeFile 'Open score file
                    Put #lngFreeFile, , Player.Score 'Write score
                    Close #lngFreeFile                   'Close file
                Else 'No highscore, but show it...
                    DDSBack.DrawText GameOptions.ResX / 2 - 110, GameOptions.ResY / 2 - 100, "Highscore:" & lngHighScore, False
                End If
            End With
            
            BlitToFront                         'Blit the above to front
            LastTick = DirectX.TickCount 'Set lasttick to currenttick
           
            If blnWaitForSpace = False Then Exit Do 'If [Space] was pressed, exit this loop
        
        End If
    Loop
End Sub

