Attribute VB_Name = "mdlStars"
Option Explicit

Public Sub AddStars(X As Long, Y As Long)
 'Purpose: Adding stars at the specified x,y position
  Dim I As Integer
  Dim lngStarCount As Long
    
    'Add stars until 4 stars have been reached
    For lngStarCount = 0 To 3 'zero based 1,2,3 + 0 = 4
    
        For I = 1 To TotalStars
            If Stars(I).Enabled = False Then GoTo AddNewStars 'Check if there are some disabled stars...
        Next I
        
        'If there are no free stars...
        TotalStars = TotalStars + 1
        I = TotalStars
        ReDim Preserve Stars(TotalStars)
    
AddNewStars:
        Randomize
        With Stars(I)
            .Star = Int(Rnd * 3)
            .Pattern = lngStarCount 'Pattern is given by it's number in this loop (lngstarcount)
            .X = X
            .Y = Y
            .Alpha = 1                   'For addition fading...
            .Enabled = True
            .TimeOut = DirectX.TickCount 'Set tick to currenttick
            'lngStarCount = lngStarCount
        End With
    Next lngStarCount
End Sub

Public Sub ShowStars()
 'Purpose: Blitting the stars, and updating them position...
 Dim I As Integer, TempRect As RECT
 
    For I = 1 To TotalStars
         With Stars(I)
              If .Enabled = True Then
                ' "Explode" stars
                Select Case .Pattern 'Select star movement. Start with 0 (zero based)
                     Case 0
                        Randomize
                        .X = .X - Sin((0.6 - 0.4) * Rnd + 0.6) * 10
                        .Y = .Y - Cos((0.6 - 0.4) * Rnd + 0.6) * 10
                     Case 1
                        Randomize
                        .X = .X + Cos((0.3 - 0.5) * Rnd + 0.3) * 10
                        .Y = .Y + Cos((0.3 - 0.5) * Rnd + 0.3) * 10
                     Case 2
                        Randomize
                        .X = .X - Sin((0.8 - 0.5) * Rnd + 0.5) * 10
                        .Y = .Y + Cos((0.8 - 0.5) * Rnd + 0.5) * 10
                     Case 3
                        Randomize
                        .X = .X + Cos((0.3 - 0.8) * Rnd + 0.8) * 10
                        .Y = .Y - Cos((0.3 - 0.8) * Rnd + 0.8) * 10
                End Select
       
              If (DirectX.TickCount - .LastTick) > 100 Then
                  .Star = .Star + 1 'Update star animation, 10times/sec
                   If .Star > 2 Then .Star = 0
                    .LastTick = DirectX.TickCount 'Set lasttick  to currenttick
             End If
       
       
             If GameOptions.AlphaStars = True Then 'If alphablending is enabled, fade the stars...
                .Alpha = .Alpha - 0.03
                If .Alpha <= 0 Then
                    .Alpha = 1
                    .Enabled = False
                End If
            Else
                If (DirectX.TickCount - .TimeOut) > 1000 Then 'Else... Terminate stars after 1 sec.
                    .Enabled = False
                    .LastTick = DirectX.TickCount
                End If
            End If
       
       'If stars reach borders of screen (the scrolling part), disable them
            If .X < BackGroundX Or .X > (BackGroundX + 640) Then .Enabled = False '
            If .Y < 0 Or .Y > GameOptions.ResY Then .Enabled = False
       
            With TempRect
                .Top = 120
                .Bottom = 150
                .Left = 32 * Stars(I).Star 'Star animation
                .Right = .Left + 32
            End With
            
       'Check if star is still enabled, after checking for timeout or offscreen
            If .Enabled = True Then
                If .Alpha = 1 Then
                     DDSBack.BltFast .X, .Y, ddsSprites, TempRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
                Else
                     TransparantBlit .X, .Y, TempRect, ddsSprites, .Alpha, 50712 'latter = transparant color
                End If
            End If
        End If
     End With
    Next I
End Sub
